unit FindUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type TFindReconOpt = (frAny, frRec, frUnrec);
type TFindDateOpt = (fdAny, fdLess, fdGreater);
type TFindDir = (fdUp, fdDown);

type
  TFindForm = class(TForm)
    Label1: TLabel;
    FindEdit: TEdit;
    rgReconciled: TRadioGroup;
    gbDate: TGroupBox;
    dtpFindDate: TDateTimePicker;
    rbDateAny: TRadioButton;
    rbDateLT: TRadioButton;
    rbDateGT: TRadioButton;
    btnOK: TButton;
    btnCancel: TButton;
    rgDirection: TRadioGroup;
    cbWrap: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    function GetFindWrap: Boolean;
    procedure SetFindWrap(const Value: Boolean);
    function GetFindDir: TFindDir;
    procedure SetFindDate(const Value: TDateTime);
    procedure SetFindDateOpt(const Value: TFindDateOpt);
    procedure SetFindDir(const Value: TFindDir);
    procedure SetFindReconOpt(const Value: TFindReconOpt);
    procedure SetFindText(const Value: string);
    function GetFindDate: TDateTime;
    function GetFindDateOpt: TFindDateOpt;
    function GetFindReconOpt: TFindReconOpt;
    function GetFindText: string;
    { Private declarations }
  public
    { Public declarations }
    property FindText: string read GetFindText write SetFindText;
    property FindDate: TDateTime read GetFindDate write SetFindDate;
    property FindDateOpt: TFindDateOpt read GetFindDateOpt write SetFindDateOpt;
    property FindReconOpt: TFindReconOpt read GetFindReconOpt write SetFindReconOpt;
    property FindDirection: TFindDir read GetFindDir write SetFindDir;
    property FindWrap: Boolean read GetFindWrap write SetFindWrap;
  end;

implementation

{$R *.dfm}

procedure TFindForm.btnOKClick(Sender: TObject);
begin
  if Trim(FindEdit.Text) <> '' then
    ModalResult := mrOk;
end;

procedure TFindForm.FormCreate(Sender: TObject);
begin
  // Set initial options
  // (Don't do it in OnShow or we'll clobber the properties set by the caller!)
  dtpFindDate.DateTime := Date;
  rgReconciled.ItemIndex := Ord(frAny);
  rbDateAny.Checked := True;
  rgDirection.ItemIndex := Ord(fdDown);
end;

function TFindForm.GetFindDate: TDateTime;
begin
  Result := dtpFindDate.DateTime;
end;

procedure TFindForm.SetFindDate(const Value: TDateTime);
begin
  dtpFindDate.DateTime := Value;
end;

function TFindForm.GetFindDateOpt: TFindDateOpt;
begin
  if rbDateLT.Checked then
    Result := fdLess
  else if rbDateGT.Checked then
    Result := fdGreater
  else
    Result := fdAny;
end;

procedure TFindForm.SetFindDateOpt(const Value: TFindDateOpt);
begin
  if Value = fdLess then
    rbDateLT.Checked := True
  else if Value = fdGreater then
    rbDateGT.Checked := True
  else
    rbDateAny.Checked := True;
end;

function TFindForm.GetFindDir: TFindDir;
begin
  Result := TFindDir(rgDirection.ItemIndex);
end;

procedure TFindForm.SetFindDir(const Value: TFindDir);
begin
  rgDirection.ItemIndex := Ord(Value);
end;

function TFindForm.GetFindReconOpt: TFindReconOpt;
begin
  Result := TFindReconOpt(rgReconciled.ItemIndex);
end;

procedure TFindForm.SetFindReconOpt(const Value: TFindReconOpt);
begin
  rgReconciled.ItemIndex := Ord(Value);
end;

function TFindForm.GetFindText: string;
begin
  Result := Trim(FindEdit.Text);
end;

procedure TFindForm.SetFindText(const Value: string);
begin
  FindEdit.Text := Value;
end;

function TFindForm.GetFindWrap: Boolean;
begin
  Result := cbWrap.Checked;
end;

procedure TFindForm.SetFindWrap(const Value: Boolean);
begin
  cbWrap.Checked := Value;
end;

end.
